/***********************************************************
		maketbl.c -- makes decoding table
***********************************************************/
#include	"lh386.h"

#include	"slidehuf.h"
#include	"intrface.h"

#ifdef	__HIGHC__
#	pragma	On(Align_labels);
#endif


void		make_table(short nchar, uchar bitlen[], short tablebits, ushort table[])
{
	ushort		count[17];		/* R[hƂ̏o */
	ushort		weight[17]; 	/* 0x10000ul >> bitlen */
	ushort		start[17];		/*  bitlen ̍ŏ̃R[hil߁j */
	ushort		total;
	uint		i;
	int 		j, k, l, m, n, avail;
	ushort	   *p;

	avail = nchar;

	/*  */
	for (i = 1; i <= 16; i++)
	{
		count[i] = 0;
		weight[i] = 1u << (16 - i);
	}

	/* o񐔂𐔂 */
	for (i = 0; i < nchar; i++)
		count[bitlen[i]]++;

	/* ŏ̃R[ȟvZ */
	total = 0;
	for (i = 1; i <= 16; i++)
	{
		start[i] = total;
		total += weight[i] * count[i];
	}
	if ((total & 0xFFFF) != 0)
		error(BROKENARC, "Bad table (5)");

	/* table 쐬̂߁Atable ɓ镔El߂ɕύX */
	m = 16 - tablebits;
	for (i = 1; i <= tablebits; i++)
	{
		start[i] >>= m;
		weight[i] >>= m;
	}

	/* table R[ĥ߂̏ */
	j = start[tablebits + 1] >> m;
	k = 1 << tablebits;
	if (j != 0)
		for (i = j; i < k; i++)
			table[i] = 0;

	/* table, tree ̍쐬 */
	for (j = 0; j < nchar; j++)
	{
		k = bitlen[j];
		if (k == 0)
			continue;
		l = start[k] + weight[k];
		if (k <= tablebits)
		{
			/* table ɔ[܂R[h */
			for (i = start[k]; i < l; i++)
				table[i] = j;
		} else
		{
			/* table ɔ[܂ȂR[h */
			p = &table[(i = start[k]) >> m];
			i <<= tablebits;
			n = k - tablebits;
			/*  n  tree  */
			while (--n >= 0)
			{
				if (*p == 0)
				{
					/* }܂тĂȂ΍ */
					right[avail] = left[avail] = 0;
					*p = avail++;
				}
				if (i & 0x8000)
					p = &right[*p];
				else
					p = &left[*p];
				i <<= 1;
			}
			*p = j;
		}
		/* bitlen  k ̎̃̕R[h */
		start[k] = l;
	}
}
